<?php

namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DTO;

use Zeedhi\Framework\DataSource;


class NotafiscalLancamentoEntrada extends \Teknisa\DF\Controllers\TeknisaCrud {

    const DATASOURCE_NOTAFISCAL_FORN = 'notafiscal_fornecedor_lancamento';
    const DATASOURCE_NOTAFISCAL_CLIE = 'notafiscal_cliente_lancamento';
    const DATASOURCE_NOTAFISCAL_FILI = 'notafiscal_filial_lancamento';

    protected $dataSourceName = 'notafiscal_lancamento_entrada';

    protected $parameterBagColumns = array(
        'CDTIPOOPER',
        'CDFILIRECE',
        'CDSERIEENTR',
        'DTENTRSAIDINI',
        'DTENTRSAIDFIM',
        'DTEMISSAOINI',
        'DTEMISSAOFIM',
        'CDFILIEMIT',
        'NRINSJURNF'
    );

    public function find(DTO\Request\Filter $request, DTO\Response $response) {

        $filterCriteria  = $request->getFilterCriteria();
        $conditionsFront = $filterCriteria->getConditions();
        $conditions      = array();
        $defaultCondition = array("columnName" => "", "operator" => "=", "value" => "");
        
        $this->dataSourceName = 'notafiscal_lancamento_entrada';

        $keyRemoveIdorigdestnf = null;

        foreach ($conditionsFront as $key => &$condition) {
        
            if ($condition['columnName'] === 'IDORIGDESTNF') {

                $idorigdestnf = str_split($condition['value']);

                switch ($idorigdestnf) {
                    case in_array('F', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_FORN;
                    
                        break;
                    case in_array('C', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_CLIE;
                        break;
                    case in_array('L', $idorigdestnf):
                        $this->dataSourceName = self::DATASOURCE_NOTAFISCAL_FILI;
                        break;
                }

                $keyRemoveIdorigdestnf = $key;
            }
            
            else if($condition["columnName"] == 'DTENTRSAID') {
                $defaultCondition["columnName"]  = "DTENTRSAIDINI";
                $defaultCondition["value"] = $condition["value"][0];
                array_push($conditions, $defaultCondition);
                $defaultCondition["columnName"]  = "DTENTRSAIDFIM";
                $defaultCondition["value"] = $condition["value"][1];
                array_push($conditions, $defaultCondition);
            }
            else if($condition["columnName"] == 'CDTIPOOPER') {
                $condition["value"] = '_'.$condition["value"].'_';
                array_push($conditions, $condition);
            }
            else {
                array_push($conditions, $condition);
            }
        }
        
        $filter = new DataSource\FilterCriteria($this->dataSourceName, $conditions, $filterCriteria->getPage(), $filterCriteria->getPageSize());

        $request = new DTO\Request\Filter($filter, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        
        parent::find($request, $response);
    }

}