<?php

namespace Teknisa\DF\Modules\Entrada\Factories;

use Doctrine\ORM\EntityManager;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
    
class Dfe47000LiberacaoParaFinanceiroFactory {

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getDadosFilter($cdFilial) {
        $sql = "SELECT E.CDEMPRESA, E.NMEMPRESA, PF.DTPROCESSA 
                FROM EMPRESA E, FILIAL F, PARAMFILIAL PF
                WHERE F.CDFILIAL  = :P_CDFILIAL
                 AND  F.CDEMPRESA = E.CDEMPRESA
                 AND  F.CDFILIAL  = PF.CDFILIAL";

        $params = array("P_CDFILIAL" => $cdFilial);
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll()[0];
    }
    
    public function find($params) {
        $sql = "SELECT A.CDFILIAL, A.DTENTRSAID, A.CDOPERAPRO, A.NRLANCTONF,
                   A.IDDOCFISCAL, A.IDENTRSAIDOP, A.CDEMPRESA, A.IDDOCFINANC,
                   A.CDTIPOOPER, A.IDTPIJURNF, A.NRNOTAFISC, A.CDSERIEENTR,
                   A.NRINSJURNF, A.IDSTATUSNFE AS IDSTATUS, A.CDFORNECED, A.NRLANCTBDOC,
                   A.NRLANCTBAJUS, A.VRNOTAFISC, A.IDERROS, A.IDAVISOS,
                   A.DTAPROVACAO, A.NMRAZSOCFORN, A.IDERROAVISO, A.CDFILIRECE,
                   A.IDCHECK, A.IDBLOQUEADO, A.CDCLIENTE, A.CDTPCTPAGOP,
                   A.DTEMISSAO, C.NMRAZSOCCLIE, FI.NMFILIAL, A.IDORIGDESTNF,
                   A.CDFILIEMIT, A.IDCONTABOPER, C.VRPEMORBCLI, C.VRPEMULBCLI,
                   A.NMTIPOOPER AS NMTIPOOPERV, A.CDCLAFINOP, SUBSTR(A.CDFILIRECE||'  '||A.NMFILIAL,1,34) AS DSFILIRECE,
                   A.CDINTEGRACAO, A.CDTPBAIXAPAG, A.IDAGRUBOLFOR,
                   A.IDVENCIMENTO, A.IDUTILVENC, A.IDGERAVENC, A.IDBLOQNFFIN, A.IDNFGERADAVIAXML,
                   A.NRACESSONFE, A.CDINSCESTA, A.NMFILIAL, A.NMOPERADOR
              FROM CLIENTE C, FILIAL FI,
                   (SELECT NF.CDFILIAL, NF.IDBLOQUEADO, NVL(NF.CDOPERACTPG,NF.CDOPERAPRO) AS CDOPERAPRO, NF.NRLANCTONF,
                           NF.IDDOCFISCAL, NF.IDENTRSAIDOP, NF.CDEMPRESA, NF.IDDOCFINANC,
                           NF.CDTIPOOPER, NF.IDTPIJURNF, NF.NRNOTAFISC, NF.CDSERIEENTR,
                           NF.NRINSJURNF, NF.IDSTATUS, NF.CDFORNECED, NF.NRLANCTBDOC,
                           NF.VRNOTAFISC, NF.IDERROS, NF.IDAVISOS, NF.DTAPROVACAO,
                           NF.CDCLIENTE, NF.DTEMISSAO, F.NMRAZSOCFORN, NF.CDFILIEMIT,
                           NF.IDORIGDESTNF, NF.NRLANCTBAJUS, FR.NMFILIAL, T.NMTIPOOPER,
                           T.IDCONTABOPER, T.CDTPCTPAGOP, TP.CDCLASSFINA AS CDCLAFINOP, (' ')AS IDERROAVISO, NF.CDFILIRECE,
                           NF.CDINTEGRACAO,F.CDTPBAIXAPAG, F.IDAGRUBOLFOR,
                           ('U') AS IDCHECK, NF.DTENTRSAID, T.IDUTILVENC, T.IDGERAVENC,
                          (SELECT DECODE(NVL(MAX(C.NRSEQVENPAG),NULL), NULL, 'N', 'S')
                             FROM CONTAPAGAR  C
                            WHERE C.CDFILIAL = NF.CDFILIAL
                              AND C.NRLANCTONF = NF.NRLANCTONF) AS IDVENCIMENTO,
                           NF.IDBLOQNFFIN, NVL(NF.IDNFGERADAVIAXML, 'N') IDNFGERADAVIAXML,
                           NF.NRACESSONFE, NF.CDINSCESTA, O.NMOPERADOR, NF.IDSTATUS AS IDSTATUSNFE
            
                      FROM NOTAFISCAL NF, FORNECEDOR F, TIPOCTPAGAR TP, OPERADOR O,
                           (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER, IDCONTABOPER, CDTPCTPAGAR AS CDTPCTPAGOP, IDGERAVENCNFAP,
                                   IDUTILVENC, IDGERAVENC
                              FROM TIPOOPERAC
                             WHERE IDENTRSAIDOP = 'E'
                               AND (INSTR(:TIPOOPER,'_'||CDTIPOOPER||'_') > 0) OR (:TIPOOPER = 'T')) T,
                           (SELECT CDFILIAL, NMFILIAL
                              FROM FILIAL
                             WHERE (INSTR(:FILIAL,'_'||CDFILIAL||'_') > 0) OR (:FILIAL = 'T')) FR,
                           (SELECT 'DFE' IDSISTEMA FROM PARAMGERAL
                             WHERE CDPARGERAL = '0001'
                             UNION
                            SELECT 'EST' IDSISTEMA FROM PARAMGERAL
                             WHERE CDPARGERAL = '0001'
                             UNION
                            SELECT 'SUV' IDSISTEMA FROM PARAMGERAL
                             WHERE CDPARGERAL = '0001') SISTEMA
                     WHERE NF.CDFILIRECE = FR.CDFILIAL
                       AND NF.CDEMPRESA = :EMPRESA
                       AND O.CDOPERADOR = NVL(NF.CDOPERACTPG,NF.CDOPERAPRO)
                       AND NF.IDENTRSAIDOP = 'E'
                       AND NF.CDFORNECED = F.CDFORNECED(+)
                       AND ((INSTR(:SERIE,'_'||CDSERIEENTR||'_') > 0) OR (:SERIE = 'T'))
                       AND NF.IDENTRSAIDOP = T.IDENTRSAIDOP
                       AND NF.CDTIPOOPER = T.CDTIPOOPER
                       AND T.CDTPCTPAGOP = TP.CDTPCTPAGAR(+)
                       AND (NVL(NF.IDSISTEMA,'DFE') = SISTEMA.IDSISTEMA)
                       AND (NF.IDSTATUS IN ('A', 'E'))
                       AND (:EMISSAO = 'T' OR (NF.DTEMISSAO  BETWEEN :EMISINI AND :EMISFIM))
                       AND (NF.DTENTRSAID BETWEEN :ENTRINI AND :ENTRFIM)
                       AND ((SUBSTR(NF.IDERROS,1,1) = :ERRO) OR (:ERRO = '0'  AND NF.IDERROS  IS NULL) OR
                            (:ERRO  = 'T'))
                       AND ((SUBSTR(NF.IDAVISOS,1,1) = :AVISO) OR (:AVISO = '0' AND NF.IDAVISOS IS NULL) OR
                            (:AVISO = 'T'))
                       AND ((IDBLOQNFFIN = :IDBLOQNFFIN) OR (:IDBLOQNFFIN = 'T'))
                       AND EXISTS (SELECT CDFILIAL, NRLANCTONF
                                     FROM CONTAPAGAR CP
                                    WHERE NF.CDFILIAL = CP.CDFILIAL
                                      AND NF.NRLANCTONF = CP.NRLANCTONF)) A
             WHERE A.CDFILIEMIT = FI.CDFILIAL(+)
               AND A.CDCLIENTE = C.CDCLIENTE(+)
             ORDER BY 22, 2";
             
        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
    public function cancelaVencimento($cdFilial, $nrLanctonf) {
        $procedure = new StoredProcedure($this->connection, 'CANCELA_DADOS_FINANCEIRO');
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT,    $cdFilial,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT,  $nrLanctonf,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDCANFIN', Param::PARAM_INPUT,    'N',                Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_RETORNO', Param::PARAM_OUTPUT,     '',                Param::PARAM_TYPE_STR, 1));
        $erro = $procedure->execute();
        if(isset($erro["P_RETORNO"])) {
            switch ($erro["P_RETORNO"]) {
                case '0': 
                    break;
                case '1':
                    throw new \Exception("Operação bloqueada. Documento possui boletos baixados.");
                    break;
                case '2':
                    throw new \Exception("Operação bloqueada. Documento possui vencimentos parcelados.");
                    break;
                case '3':
                    throw new \Exception("Operação bloqueada. Documento com vencimentos prorrogados.");
                    break;
                case '4':
                    throw new \Exception("Operação bloqueada. Documento com ajustes em boletos.");
                    break;
                case '5':
                    throw new \Exception("Operação bloqueada. Documento com boleto real.");
                    break;
                case '6':
                    throw new \Exception("Operação bloqueada. Documento relacionado à um boleto CNAB.");
                    break;
                case '7':
                    throw new \Exception("Operação bloqueada. Documento com boleto associado.");
                    break;
                default: 
                    throw new \Exception("Ocorreu um erro ao cancelar o vencimento.");
                    break;
            }   
        }
    }
    
    public function updateIdBloqueado($idbloqnfin, $cdoperactpg, $cdoperactpgcan, $dtliberacaofin, $cdfilial, $nrlanctonf) {
        $sql = "UPDATE NOTAFISCAL
                SET IDBLOQNFFIN = :P_IDBLOQNFIN,
                 CDOPERACTPG    = :P_CDOPERACTPG,
                 CDOPERACTPGCAN = :P_CDOPERACTPGCAN,
                 DTLIBERACAOFIN = :P_DTLIBERACAOFIN
                WHERE CDFILIAL  = :P_CDFILIAL
                AND NRLANCTONF  = :P_NRLANCTONF";
                
        $params = array("P_IDBLOQNFIN" => $idbloqnfin,
                        "P_CDOPERACTPG" => $cdoperactpg,
                        "P_CDOPERACTPGCAN" => $cdoperactpgcan,
                        "P_DTLIBERACAOFIN" => $dtliberacaofin,
                        "P_CDFILIAL" => $cdfilial,
                        "P_NRLANCTONF" => $nrlanctonf);
        
        $query = $this->connection->prepare($sql);
        return $query->execute($params);
    }
    
    public function getParamManifesta() {
        $sql = "SELECT NVL(IDCIENCIAEMISS, '0' ) IDCIENCIAEMISS, NVL(IDCONFIRMAEMISS, '0') IDCONFIRMAEMISS
                   FROM PARAMMANIFESTA";
                   
        $query = $this->connection->prepare($sql);
        $query->execute();
        return $query->fetchAll()[0];
    }
    
    public function getInscricaoEmpresa($cdEmpresa) {
        $sql = "SELECT NRINSJUREMPR FROM EMPRESA WHERE CDEMPRESA = :P_CDEMPRESA";
        
        $params = array("P_CDEMPRESA" => $cdEmpresa);
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll()[0];
    }
}
